/*Javascript reference library and help files for the Scriptease PDF Javascript editor.   Bryan Guignard, Adobe Certified Expert, 1999. All Rights Reserved.*/

/*Version francaise JR Boulay 2006, tous droits rservs. www.abracadabrapdf.net*/


/*The following functions create the Acrobat Forms 
Javascript pop up menus that are accessible through 
the bookmarks under the Acrobat Forms Javascript bookmark*/


function AppObject()
{
global.AppObjectMenu = app.popUpMenu(
['App Object Properties',
'app.formsVersion',
'app.fullscreen',
'app.language',
'app.numPlugins',
'app.openInPlace',
'app.platform',
'app.toolbar',
'app.toolbarHorizontal',
'app.toolbarVertical',
'app.viewerType',
'app.viewerVersion'],
['App Object Methods',
'app.alert',
'app.beep',
'app.execMenuItem',
'app.getNthPlugInName',
'app.goBack',
'app.goForward',
'app.hideMenuItem',
'app.hideToolbarButton',
'app.mailMsg',
'app.response']);
global.Return = global.AppObjectMenu;
}


function ColorObject()
{
global.ColorObjectMenu = app.popUpMenu(
'color.transparent',
'color.black',
'color.white',
'color.red',
'color.green',
'color.blue',
'color.cyan',
'color.magenta',
'color.yellow',
'color.dkGray',
'color.gray',
'color.ltGray');
global.Return = global.ColorObjectMenu;
}


function ConsoleMethods()
{
global.ConsoleMethodsMenu = app.popUpMenu(
'console.show',
'console.hide',
'console.println',
'console.clear');
global.Return = global.ConsoleMethodsMenu; 
}


function DocObject()
{
global.DocObjectPropertiesMenu = app.popUpMenu(
['Doc Object Properties',
'author',
'calculate',
'creator',
'creationDate',
'delay',
'dirty',
'external',
'filesize',
'keywords',
'modDate',
'numFields',
'numPages',
'numTemplates',
'path',
'pageNum',
'producer',
'subject',
'title',
'zoom',
'zoomType'],
['Doc Object methods',
'calculateNow',
'exportAsFDF',
'getField',
'getNthFieldName',
'getNthTemplate',
'getURL',
'gotoNamedDest',
'importAnFDF',
'mailDoc',
'mailForm',
'print',
'resetForm',
'scroll',
'spawnPageFromTemplate',
'submitForm']);
global.Return = global.DocObjectPropertiesMenu;
}


function EventObjectProperties()
{
global.EventObjectPropertiesMenu = app.popUpMenu(
'change',
'commitKey',
'modifier',
'rc',
'selEnd',
'selStart',
'shift',
'target',
'value',
'willCommit');
global.Return = global.EventObjectPropertiesMenu;
}


function FieldProperties()
{
global.FieldPropertiesMenu = app.popUpMenu(
['borderStyle',
'borderStyle',
'border.s',
'border.b',
'border.d',
'border.i',
'border.u'],
'calcOrderIndex',
'charLimit',
'defaultValue',
'delay',
['display',
'display.visible',
'display.hidden',
'display.noPrint',
'display.noView'],
'doc',
'editable',
'fillColor',
'hidden',
['highlight',
'highlight.n',
'highlight.i',
'highlight.p',
'highlight.o'],
'lineWidth',
'multiline',
'name',
'numItems',
'password',
'print',
'readonly',
'required',
'strokeColor',
['style',
'style.ch',
'style.cr',
'style.di',
'style.ci',
'style.st',
'style.sq'],
'textColor',
['textFont',
'font.Times',
'font.TimesB',
'font.TimesI',
'font.TimesBI',
'font.Helv',
'font.HelvB',
'font.HelvI',
'font.HelvBI',
'font.Cour',
'font.CourB',
'font.CourI',
'font.CourBI',
'font.Symbol',
'font.ZapfD'],
'textSize',
'type',
'userName',
'value');
global.Return = global.FieldPropertiesMenu;
}


function FieldMethods()
{
global.FieldMethodsMenu = app.popUpMenu(
'buttonImportIcon',
'clearItems',
'deleteItemAt',
'getArray',
'getItemAt',
'insertItemAt',
'setItems');
global.Return = global.FieldMethodsMenu;
}


function GlobalObjectMethods()
{
global.GlobalObjectMethodsMenu = app.popUpMenu(
'global',
'global.setPersistent');
global.Return = global.GlobalObjectMethodsMenu;
}


function UtilObject()
{
global.UtilObjectMenu = app.popUpMenu(
'printf',
'printx',
'printd',
'scand');
global.Return = global.UtilObjectMenu;
}


function MathProperties()
{
global.MathPropertiesMenu = app.popUpMenu(
'Math.E',
'Math.LN2',
'Math.LN10',
'Math.LOG2E',
'Math.LOG10E',
'Math.PI',
'Math.SQRT1_2',
'Math.SQRT2');
global.Return = global.MathPropertiesMenu;
}


function MathMethods()
{
global.MathMethodsMenu = app.popUpMenu(
'Math.abs',
'Math.acos',
'Math.asin',
'Math.atan',
'Math.atan2',
'Math.ceil',
'Math.cos',
'Math.exp',
'Math.floor',
'Math.log',
'Math.max',
'Math.min',
'Math.pow',
'Math.random',
'Math.round',
'Math.sin',
'Math.sqrt',
'Math.tan',
'Math.toString');
global.Return = global.MathMethodsMenu;
}


function StringMethods()
{
global.StringMethodsMenu = app.popUpMenu(
'charAt',
'charCodeAt',
'concat',
'fromCharCode',
'indexOf',
'lastIndexOf',
'match',
'replace',
'search',
'slice',
'split',
'substr',
'substring',
'toLowerCase',
'toUpperCase');
global.Return = global.StringMethodsMenu;
}


function StringProperties()
{
global.StringPropertiesMenu = app.popUpMenu(
'length',
'prototype');
global.Return = global.StringPropertiesMenu;
}


function Assorted()
{
global.AssortedMenu = app.popUpMenu(
'arguments',
'arguments.callee',
'arguments.caller',
'arguments.length',
'break',
'continue',
'delete',
'do{}while',
'escape',
'eval',
'export',
'for(in)',
'function',
'if',
'if{}else',
'import',
'inNaN',
'label',
'NaN',
'new',
'parseFloat',
'parseInt',
'return',
'switch',
'this',
'typeof',
'unescape',
'var',
'void',
'while',
'with');
global.Return = global.AssortedMenu;
}


function NumberMethods()
{
global.NumberMethodsMenu = app.popUpMenu(
'number.toSource',
'number.toString',
'number.valueOf');
global.Return = global.NumberMethodsMenu;
}


function NumberProperties()
{
global.NumberPropertiesMenu = app.popUpMenu(
'Number.MAX_VALUE',
'Number.MIN_VALUE',
'Number.NaN',
'Number.NEGATIVE_INFINITY',
'Number.POSITIVE_INFINITY',
'Number.prototype',
'number.prototype',
'number.toSource',
'number.toString',
'number.valueOf');
global.Return = global.NumberPropertiesMenu;
}


function FunctionProperties()
{
global.FunctionPropertiesMenu = app.popUpMenu(
'Function.arguments',
'Function.arity',
'Function.caller',
'Function.prototype');
global.Return = global.FunctionPropertiesMenu;
}


function FunctionMethods()
{
global.FunctionMethodsMenu = app.popUpMenu(
'Function.apply',
'Function.call',
'Function.toSource',
'Function.toString');
global.Return = global.FunctionMethodsMenu;
}


function ArrayMethods()
{
global.ArrayMethodsMenu = app.popUpMenu(
'array.concat',
'array.join',
'array.pop',
'array.push',
'array.reverse',
'array.shift',
'array.slice',
'array.sort',
'array.splice',
'array.toString',
'array.unshift',
'array.valueOf');
global.Return = global.ArrayMethodsMenu;
}


function ArrayProperties()
{
global.ArrayPropertiesMenu = app.popUpMenu(
'array.length',
'array.prototype');
global.Return = global.ArrayPropertiesMenu;
}


function BooleanMethods()
{
global.BooleanMethodsMenu = app.popUpMenu(
'boolean.toString',
'boolean.valueOf');
global.Return = global.BooleanMethodsMenu;
}


function BooleanProperties()
{
global.BooleanPropertiesMenu = app.popUpMenu(
'Boolean.prototype');
global.Return = global.BooleanPropertiesMenu;
}


function ObjectMethods()
{
global.ObjectMethodsMenu = app.popUpMenu(
'object.eval',
'object.toString',
'object.unwatch',
'object.valueOf',
'object.watch');
global.Return = global.ObjectMethodsMenu;
}


function ObjectProperties()
{
global.ObjectPropertiesMenu = app.popUpMenu(
'object.prototype',
'object.constructor');
global.Return = global.ObjectPropertiesMenu;
}


function RegularExpressionMethods()
{
global.RegularExpressionMethodsMenu = app.popUpMenu(
'regexp.compile',
'regexp.exec',
'regexp.test');
global.Return = global.RegularExpressionMethodsMenu;
}


function RegularExpressionProperties()
{
global.RegularExpressionPropertiesMenu = app.popUpMenu(
'RegExp,$',
'RegExp,$*',
'RegExp,$&',
'RegExp,$_',
'RegExp,$`',
'RegExp,$\'',
'RegExp,$+',
'RegExp,$',
'regexp.global',
'regexp.ingoreCase',
'regexp.input',
'regexp.lastIndex',
'regexp.lastMatch',
'regexp.lastParen',
'regexp.leftContext',
'regexp.multiline',
'regexp.rightContext',
'regexp.source');
global.Return = global.RegularExpressionPropertiesMenu;
}



/*The InsertScript function is used to apply the Scriptease dynamic code cuts to either the Testease window or the Editease window*/

function InsertScript()
{
global.pattern = new RegExp("#", "g");
global.insertScriptOne = this.getField("P" + this.pageNum + ".Scriptease.codeInput").value;
global.insertScriptTwo = this.getField("P" + this.pageNum + ".Scriptease.lockable.editWindow").value;
global.toggleBookmarks = this.getField("P" + this.pageNum + ".Scriptease.useBookmarks").value;
global.insertOne = this.getField("P" + this.pageNum + ".Scriptease.codeInput");
global.insertTwo = this.getField("P" + this.pageNum + ".Scriptease.lockable.editWindow");


 /*prevent error message from happening if user opens a menu but doesn't make a selection*/

if (global.Return == null) xyz = 0;  


 /*determine if the return menu value will be placed in the Testease window or the Editease window*/

else if (global.toggleBookmarks == "yes")  

/*replace # symbol(s) with contents of return value in Testease code input window*/
{
global.pat = global.insertScriptOne.replace(global.pattern,global.Return);
global.insertOne.value = global.pat;
}

/*if the Editease window is locked then prevent return menu value from being added to it and display warning message*/

else if (global.insertScriptTwo.readonly == true)
app.alert("Cette fiche est verrouill\u00E9e !", 1, 0); 

else

/*replace # symbol(s) with contents of return value in Editease window*/
{
global.pat = global.insertScriptTwo.replace(global.pattern,global.Return);
global.insertTwo.value = global.pat;
}
}
